:#####################################################
: Create WAV file starting from binary code.
: 
: First parameter: button name (i.e. batch file containing instructions to create raw command)
: Second parameter: output file name (no extension, .wav will be added).
: 
:#####################################################

: @echo off

if exist .\sox.exe goto ok

:ok
if not exist .\%1%.bat goto commandnotfound
if (%sox%) == () set sox=.\
if not exist %sox%\sox.exe goto soxnotfound

if (%1) == () goto error
if (%2) == () goto error
: set num = %3%
: if (%num%) == () set num=0

: create raw code:

echo Creating command...
: add code for specified button:
call %1.bat

echo Adding silence after command...
: add 30 ms silence after any command iteration:
sox -c1 -r48000 -n -t raw - synth 0.030 sine 18000 vol 0 >>base.raw

echo Base command created.
: write command+silence at least once:
echo Storing first command occurrence...
type  base.raw  > all.raw
if (%3) == (0) goto oltre:
if (%3) == () goto oltre:

echo Adding %3 command occurrence(s)...
: repeat command+silence and join into single signal:
for /L %%i in (1,1,%3) do type  base.raw   >> all.raw

:oltre
: add final 100 ms silence:
echo Adding final silence...
sox -c1 -r48000 -n -t raw - synth 0.100 sine 18000 vol 0 >>all.raw


: Convert to WAV format
echo Creating '%2.wav' file...
call conv.bat %2
echo **** File '%2.wav' created.
goto end

:commandnotfound
@echo *** ERROR - Command file '%1.bat' not found
goto end

:soxnotfound
@echo *** ERROR - 'SOX' executable not found
goto end

:error
@echo *** Syntax error  
@echo create  button_name output_file [num]
@echo 'button_name' is the name of the batch file which creates the RAW data (with no extension);
@echo 'output_file' is name of output WAV file, with no extension.
@echo 'num' is the number of additional occurrences of the command (in case the device does no react to a single one)

:end
echo Done 
